glibmm: Gio::UnixConnection Class Reference

glibmm 2.30.1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Related Functions
Gio::UnixConnection Class Reference
Portable Network I/O Functionality

A Unix domain SocketConnection. More...

`#include <giomm/unixconnection.h>`

Inheritance diagram for Gio::UnixConnection:
[legend]

List of all members.

## Public Member Functions
virtual | ~UnixConnection ()
GUnixConnection* | gobj ()
| Provides access to the underlying C GObject.
const GUnixConnection* | gobj () const
| Provides access to the underlying C GObject.
GUnixConnection* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
bool | send_fd (int fd, const Glib::RefPtr< Cancellable >& cancellable)
| Passes a file descriptor to the recieving side of the connection.
int | receive_fd (const Glib::RefPtr< Cancellable >& cancellable)
| Receives a file descriptor from the sending end of the connection.
Glib::RefPtr< Credentials > | receive_credentials (const Glib::RefPtr< Cancellable >& cancellable)
| Receives credentials from the sending end of the connection.
Glib::RefPtr< const Credentials > | receive_credentials (const Glib::RefPtr< Cancellable >& cancellable) const
| Receives credentials from the sending end of the connection.
bool | send_credentials (const Glib::RefPtr< Cancellable >& cancellable)
| Passes the credentials of the current user the receiving side of the connection.
## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::UnixConnection > | wrap (GUnixConnection* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

A Unix domain SocketConnection.

This is the subclass of SocketConnection that is created for UNIX domain sockets.

It contains functions to do some of the unix socket specific functionallity like passing file descriptors.

Since glibmm 2.24:

## Constructor & Destructor Documentation

virtual Gio::UnixConnection::~UnixConnection | ( |  | ) | `[virtual]`

## Member Function Documentation

GUnixConnection* Gio::UnixConnection::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented from Gio::SocketConnection.

const GUnixConnection* Gio::UnixConnection::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented from Gio::SocketConnection.

GUnixConnection* Gio::UnixConnection::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

Reimplemented from Gio::SocketConnection.

Glib::RefPtr<Credentials> Gio::UnixConnection::receive_credentials | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |

Receives credentials from the sending end of the connection.

The sending end has to call g_unix_connection_send_credentials() (or similar) for this to work.

As well as reading the credentials this also reads (and discards) a single byte from the stream, as this is required for credentials passing to work on some implementations.

Other ways to exchange credentials with a foreign peer includes the UnixCredentialsMessage type and g_socket_get_credentials() function.

Since glibmm 2.26:

Parameters:

  cancellable | A Cancellable or `0`.

Returns:
  Received credentials on success (free with Glib::object_unref()), `0` if error is set.

Glib::RefPtr<const Credentials> Gio::UnixConnection::receive_credentials | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) | const

Receives credentials from the sending end of the connection.

The sending end has to call g_unix_connection_send_credentials() (or similar) for this to work.

As well as reading the credentials this also reads (and discards) a single byte from the stream, as this is required for credentials passing to work on some implementations.

Other ways to exchange credentials with a foreign peer includes the UnixCredentialsMessage type and g_socket_get_credentials() function.

Since glibmm 2.26:

Parameters:

  cancellable | A Cancellable or `0`.

Returns:
  Received credentials on success (free with Glib::object_unref()), `0` if error is set.

int Gio::UnixConnection::receive_fd | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |

Receives a file descriptor from the sending end of the connection.

The sending end has to call g_unix_connection_send_fd() for this to work.

As well as reading the fd this also reads a single byte from the stream, as this is required for fd passing to work on some implementations.

Since glibmm 2.22:

Parameters:

  cancellable | Optional Cancellable object, `0` to ignore.

Returns:
  A file descriptor on success, -1 on error.

bool Gio::UnixConnection::send_credentials | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |

Passes the credentials of the current user the receiving side of the connection.

The recieving end has to call g_unix_connection_receive_credentials() (or similar) to accept the credentials.

As well as sending the credentials this also writes a single NUL byte to the stream, as this is required for credentials passing to work on some implementations.

Other ways to exchange credentials with a foreign peer includes the UnixCredentialsMessage type and g_socket_get_credentials() function.

Since glibmm 2.26:

Parameters:

  cancellable | A Cancellable or `0`.

Returns:
  `true` on success, `false` if error is set.

bool Gio::UnixConnection::send_fd | ( | int | fd,
|  | const Glib::RefPtr< Cancellable >& | cancellable
| ) |  |

Passes a file descriptor to the recieving side of the connection.

The recieving end has to call g_unix_connection_receive_fd() to accept the file descriptor.

As well as sending the fd this also writes a single byte to the stream, as this is required for fd passing to work on some implementations.

Since glibmm 2.22:

Parameters:

  fd | A file descriptor.
  cancellable | Optional Cancellable object, `0` to ignore.

Returns:
  A `true` on success, `0` on error.

## Friends And Related Function Documentation

Glib::RefPtr< Gio::UnixConnection > wrap | ( | GUnixConnection * | object,
|  | bool | take_copy = `false`
| ) |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.